
	nop							; pour le shell
	jp Depart
.dw 0
.dw Title
Depart:
	call _runindicoff
	call _clrLCD
	call _homeup				; curseur en haut de l'cran
	ld hl,Present				; cran de prsentation
	set textInverse,(iy+textflags)
	call _puts					; affiche la 1re ligne
	res textInverse,(iy+textflags)
	call _newline
	call _newline
	call _newline

	ld de,$016d
	ld (_penCol),de				; $6c->x,$01->y
	call _vputs					; affiche la 2me ligne petite police

	ld de,$0764
	ld (_penCol),de				; $3c->x,$09->y
	call _vputs					; affiche la 3me ligne petite police

	ld de,$0e63
	ld (_penCol),de				; $3c->x,$10->y
	call _vputs					; affiche la 4me ligne petite police

	call _puts					; affiche la 5me ligne

	call _newline
	call _puts					; affiche la 6me ligne

WaitKey:
	call _getkey				; attend 1 touche
	cp kExit
	jp z,Exit2
	cp kF2
	jp z,nouvellepartie
	cp kF1
	jr nz,WaitKey
;
	ld a,$C0
	out (7),a
	ld hl,sauve-1
	rst 20h
	rst 10h
	jp c,nouvellepartie
	and %00011111
	cp $0c
	jp nz,nouvellepartie
	ld a,b
	ex de,hl
	call _inc_ptr_ahl
	call _inc_ptr_ahl
	call _SET_ABS_SRC_ADDR
	xor a
	ld hl,_textShadow
	call _SET_ABS_DEST_ADDR
	xor a
	ld hl,167
	call _SET_MM_NUM_BYTES
	call _mm_ldir
	xor a
	ld hl,$FC00
	call _SET_ABS_DEST_ADDR
	xor a
	ld hl,1024
	call _SET_MM_NUM_BYTES
	call _mm_ldir
	ld b,0
	ld a,(joueur)
	cp 1
	jp z,onattend
	cp 0
	jp z,onjoue2
	cp 4
	jp z,syncro
	ld a,(type)
	cp $80
	jp z,carre4
	bit 6,a
	jr nz,lblcroi
	bit 5,a
	jr nz,lbldest
	bit 4,a
	jr nz,lblsm
	jr nouvellepartie
lblcroi:
	cp $42
	jr z,uncroi
	inc b
uncroi:
	inc b
	jp carre3
lbldest:
	cp $28
	jr z,undest
	cp $24
	jr z,deuxdest
	inc b
deuxdest:
	inc b
undest:
	inc b
	jp carre2
lblsm:
	cp $18
	jr z,unsm
	cp $14
	jr z,deuxsm
	cp $12
	jr z,troissm
	inc b
troissm:
	inc b
deuxsm:
	inc b
unsm:
	inc b
	jp carre1
;*********************************************
nouvellepartie:
	ld b,167
	ld hl,_textShadow
	call 437Bh					; b 0 @ (hl)
	call _clrLCD
	ld hl,$FCC1
	call Grille
	ld hl,$FCC9
	call Grille
	ld de,$0309
	ld (_penCol),de
	ld hl,flottes
	call _vputs
	ld de,$0246
	ld (_penCol),de
	call _vputs
	ld hl,plcbat
	call Afftexte
	ld hl,$1c1c
	ld (coord),hl
;*********************************************
	ld a,3
	ld (joueur),a
carre4:
	ld a,$80
	ld (type),a
	ld a,1
	ld (htr),a
	ld a,4
	ld (lrg),a
	call Place
	ld a,$42
	ld (type),a
	ld b,2
carre3:
	ld a,1
	ld (htr),a
	ld a,3
	ld (lrg),a
	push bc
	call Place
	pop bc
	ld hl,type
	ld (hl),$44
	djnz carre3
	ld a,$22
	ld (type),a
	ld b,3
carre2:
	ld a,1
	ld (htr),a
	ld a,2
	ld (lrg),a
	push bc
	call Place
	pop bc
	ld a,(type)
	xor %100000
	rlca
	xor %100000
	ld (type),a
	djnz carre2
	ld a,$10
	ld (type),a
	ld b,4
carre1:
	ld a,1
	ld (htr),a
	ld a,1
	ld (lrg),a
	push bc
	call Place
	pop bc
	ld a,(type)
	cp $10
	jr nz,rotate
	ld a,$11
rotate:
	xor %10000
	rlca
	xor %10000
	ld (type),a
	djnz carre1
syncro:
	ld a,4
	ld (joueur),a
	ld de,$5c1c
	ld (coord),de
	ld a,$ab
	call PutByte
	call _runindicon
waitloop:
	call GET_KEY
	cp K_EXIT
	jp z,Exit
	in a,(7)
	and 3
	cp 3
	jr z,waitloop
	call GetByte
	cp $ab
	jr z,onest1er
	cp $bc
	jr z,onestdeuxieme
	jr waitloop
onestdeuxieme:
	ld hl,joueur2
	call Afftexte
	ld a,1
	ld (joueur),a
	jr onestsyncro
onest1er:
	ld a,$bc
	call PutByte
	ld hl,joueur1
	call Afftexte
	xor a
	ld (joueur),a
	call _runindicoff
	call pause
onestsyncro:
	ld a,(joueur)
	cp 0
	jp z,onjoue
	call pause
;*********************************************
onattend:
	ld a,1
	ld (joueur),a
	ld hl,patienter
	call Afftexte
	call _runindicon
onattend1:
	call GET_KEY
	cp K_EXIT
	jp z,Exit
	in a,(7)
	and 3
	cp 3
	jr z,onattend1
	call GetByte
	cp $de
	jr z,recoitlecoup
	cp $ea
	jr z,onjoue
	cp $fb
	jr z,onaperdu
	jr onattend1
onaperdu:
	ld hl,perd
	call Afftexte
	call pause
	ld hl,sauve-1
	rst 20h
	rst 10h
	call nc,_delvar
	jp Exit2
recoitlecoup:
	call GET_KEY
	cp K_EXIT
	jp z,Exit
	in a,(7)
	and 3
	cp 3
	jr z,recoitlecoup
	call GetByte
	ld e,a
	ld d,0
	push de
	ld hl,matrice
	add hl,de
	ld a,(hl)
	call PutByte
	bit 0,(hl)
	jr nz,onattend1
	ld a,1
	or (hl)
	ld (hl),a
onattend2:
	call GET_KEY
	cp K_EXIT
	jp z,Exit
	in a,(7)
	and 3
	cp 3
	jr z,onattend2
	call GetByte
	ld c,a
	call GetByte
	sub 58
	ld b,a
	inc c
	call FP
	xor (hl)
	ld (hl),a
	jr onattend1
;*********************************************
onjoue:
	xor a
	ld (joueur),a
	call _runindicoff
onjoue2:
	ld hl,postir
	call Afftexte
ojkeyloop1:
	ld a,70
	ld (compteur),a
	call Putcurs
ojkeyloop:
	halt
	call GET_KEY
	cp 0
	jr nz,ojsuite
	ld hl,compteur
	dec (hl)
	xor a
	cp (hl)
	jr z,ojkeyloop1
	jr ojkeyloop
ojsuite:
	cp K_EXIT
	jp z,Exit
	cp K_RIGHT
	jp z,ojdroite
	cp K_LEFT
	jp z,ojgauche
	cp K_UP
	jp z,ojhaut
	cp K_DOWN
	jp z,ojbas
	cp K_SECOND
	jr z,onvalide
	jr ojkeyloop
onvalide:
	ld hl,flags
	bit 0,(hl)
	call nz,Putcurs
	ld a,(coord+1)
	rrca
	rrca				; /4
	sub 17
	ld d,a
	ld a,(coord)
	rrca
	rrca
	sub 2				; -30
	dec a
	add a,a
	ld b,a
	add a,a
	add a,a
	add a,b				; y*10
	add a,d				; +x
	ld c,a
	ld a,$de
	call PutByte
	ld a,c
	call PutByte
	ld a,$C0
	out (7),a
attendrep:
	call GET_KEY
	cp K_EXIT
	jp z,Exit
	in a,(7)
	and 3
	cp 3
	jr z,attendrep
	call GetByte
	push af
	ld a,(coord)
	call PutByte
	ld a,(coord+1)
	call PutByte
	pop af
	bit 0,a
	jp nz,dejajoue
	cp $10
	jr nc,touche
	ld bc,(coord)
	ld a,6
	add a,b
	ld b,a
	ld a,1
	add a,c
	ld c,a
	call FP
	or (hl)
	ld (hl),a
	ld hl,dansleau
	call Afftexte
	jp tsuite2
touche:
	push af
	ld ix,touch
	ld bc,(coord)
	call James_Yopp
	pop af

	ld hl,sousmarin
	cp $20
	jp c,batcoule
	ld ix,flags
	cp $40
	jr c,dest
	cp $80
	jr c,crois
	ld hl,porteavion
	ld a,(pacmptr)
	inc a
	ld (pacmptr),a
	cp 4
	jp z,batcoule
	jr battouche
;
dest:
	ld hl,destroyer
	bit 1,a
	jr nz,dest1touche
	bit 2,a
	jr nz,dest2touche
	bit 3,a
	jr nz,dest3touche
dest1touche:
	bit 1,(ix)
	jr nz,batcoule
	set 1,(ix)
	jr battouche
dest2touche:
	bit 2,(ix)
	jr nz,batcoule
	set 2,(ix)
	jr battouche
dest3touche:
	bit 3,(ix)
	jr nz,batcoule
	set 3,(ix)
	jr battouche
;
crois:
	ld hl,croiseur
	bit 1,a
	jr nz,croi1touche
	bit 2,a
	jr nz,croi2touche
croi1touche:
	bit 5,(ix)
	jr nz,batcoule
	bit 4,(ix)
	jr nz,croi1dejatouche
	set 4,(ix)
	jr battouche
croi1dejatouche:
	set 5,(ix)
	jr battouche
;
croi2touche:
	bit 7,(ix)
	jr nz,batcoule
	bit 6,(ix)
	jr nz,croi2dejatouche
	set 6,(ix)
	jr battouche
croi2dejatouche:
	set 7,(ix)
battouche:
	call Afftexte
	ld de,$3839
	ld (_penCol),de
	ld hl,touchetxt
	call _vputs
	jr tsuite
batcoule:
	call Afftexte
	ld de,$3839
	ld (_penCol),de
	ld hl,couletxt
	call _vputs
tsuite:
	ld hl,nbrtouches
	inc (hl)
tsuite2:
	call pause
	ld a,(nbrtouches)
	cp 20
	jr z,onagagne
	ld a,$ea
	call PutByte
	jp onattend
dejajoue:
	ld hl,dejoue
	call Afftexte
	call pause
	jp onjoue
;*********************************************
onagagne:
	ld a,$fb
	call PutByte
	ld hl,gagn
	call Afftexte
	call pause
	ld hl,sauve-1
	rst 20h
	rst 10h
	call nc,_delvar
	jp Exit2
;*********************************************
ojdroite:
	ld a,(coord+1)
	cp 104
	jp z,ojkeyloop
	ld hl,flags
	bit 0,(hl)
	call nz,Putcurs
	add a,4
	ld (coord+1),a
	jp ojkeyloop1
;*********************************************
ojgauche:
	ld a,(coord+1)
	cp 68
	jp z,ojkeyloop
	ld hl,flags
	bit 0,(hl)
	call nz,Putcurs
	sub 4
	ld (coord+1),a
	jp ojkeyloop1
;*********************************************
ojhaut:
	ld a,(coord)
	cp 12
	jp z,ojkeyloop
	ld hl,flags
	bit 0,(hl)
	call nz,Putcurs
	sub 4
	ld (coord),a
	jp ojkeyloop1
;*********************************************
ojbas:
	ld a,(coord)
	cp 48
	jp z,ojkeyloop
	ld hl,flags
	bit 0,(hl)
	call nz,Putcurs
	add a,4
	ld (coord),a
	jp ojkeyloop1
;---------------------------------------------------------------------
; Place un bateau
;---------------------------------------------------------------------
Place:
	jp rot
keyloop1:
	ld a,70
	ld (compteur),a
	call Putboat
keyloop:
	halt
	call GET_KEY
	cp 0
	jr nz,suite
	ld hl,compteur
	dec (hl)
	xor a
	cp (hl)
	jr z,keyloop1
	jr keyloop
suite:
	cp K_EXIT
	jp z,Exit
	cp K_RIGHT
	jp z,droite
	cp K_LEFT
	jp z,gauche
	cp K_UP
	jp z,haut
	cp K_DOWN
	jp z,bas
	cp K_XVAR
	jp z,rot
	cp K_SECOND
	jr z,onplace
	jr keyloop
;*********************************************
onplace:
	ld hl,flags
	bit 0,(hl)
	call z,Putboat
	ld hl,flags
	res 0,(hl)

	ld a,(coord+1)
	rrca
	rrca				; /4
	ld (matxy),a		; x ds matrice
	ld d,a
	ld a,(coord)
	rrca
	rrca
	sub 2				; -30
	ld (matxy+1),a		; y ds matrice
	dec a
	add a,a
	ld b,a
	add a,a
	add a,a
	add a,b				; y*10
	add a,d				; +x
	ld h,0
	ld l,a
	ld de,matrice-1
	add hl,de			; pointeur pr bateau

	push hl
	ld de,10
	ld a,(lrg)
	ld c,a
	ld a,(htr)
	ld b,a
	xor a
verifv:
	push bc
	push hl
	ld b,c
verifh:
	cp (hl)
	jp nz,onpeutpas		; peut-on le placer ?
	inc hl
	djnz verifh
	pop hl
	pop bc
	add hl,de
	djnz verifv
	pop hl

	ld a,(matxy+1)
	cp 1
	jr z,enhaut
	push hl
	sbc hl,de
	ld a,(matxy)
	cp 1
	jr z,agauche
	dec hl
	ld (hl),2
	inc hl
agauche:
	ld c,2
	call writeligne
	ld a,(lrg)			; !!!!!!!!!!!
	ld b,a
	ld a,(matxy)
	add a,b
	cp 11
	jr z,adroite
	ld (hl),2
adroite:
	pop hl
enhaut:
	ld a,(matxy)
	cp 1
	jr z,lgnde2agimp
	push hl
	dec hl
	ld a,(htr)
	ld b,a
deuxagauche:
	ld (hl),2
	add hl,de
	djnz deuxagauche
	pop hl
lgnde2agimp:
	ld a,(lrg)			; !!!!!!!!!!!!!!!!!!
	ld b,a
	ld a,(matxy)
	add a,b
	cp 11
	jr z,lgnde2adimp
	push hl
	ld a,(lrg)
	ld b,a
dechl:
	inc hl
	djnz dechl
	ld a,(htr)
	ld b,a
deuxadroite:
	ld (hl),2
	add hl,de
	djnz deuxadroite
	pop hl
lgnde2adimp:
	ld a,(htr)
	ld b,a
	ld a,(type)
	ld c,a
ehloop:
	push bc
	push hl
	call writeligne			; enregistre le bateau
	pop hl
	add hl,de
	pop bc
	djnz ehloop
	ld a,(htr)			; !!!!!!!!!!!!!!!!!!!!
	ld b,a
	ld a,(matxy+1)
	add a,b
	cp 11
	jr z,enbas
	ld a,(matxy)
	cp 1
	jr z,agauche2
	dec hl
	ld (hl),2
	inc hl
agauche2:
	ld c,2
	call writeligne
	ld a,(lrg)			; !!!!!!!!!!!!!!!!!!!!!
	ld b,a
	ld a,(matxy)
	add a,b
	cp 11
	jr z,enbas
	ld (hl),2
enbas:
	ret


onpeutpas:
	pop hl
	pop bc
	pop hl
	ld hl,flags
	set 0,(hl)
	jp keyloop1
writeligne:
	ld a,(lrg)
	ld b,a
wlloop:
	ld (hl),c
	inc hl
	djnz wlloop
	ret
;*********************************************
rot:
	ld hl,flags
	bit 0,(hl)
	jr z,rnoeff
	call Putboat
rnoeff:
	ld a,(htr)
	ld b,a
	ld a,(lrg)
	ld (htr),a
	ld a,b
	ld (lrg),a			; echange htr et lrg
	rlca \ rlca			; *4
	ld b,a
	ld a,44
	sub b
	ld b,a
	ld a,(coord+1)		; controle avec x
	cp b
	jr c,testy
	ld a,b
	ld (coord+1),a
testy:
	ld a,(htr)
	rlca \ rlca			; *4
	ld b,a
	ld a,52
	sub b
	ld b,a
	ld a,(coord)		; controle avec y
	cp b
	jp c,keyloop1
	ld a,b
	ld (coord),a
	jp keyloop1
;*********************************************
droite:
	ld a,(lrg)
	dec a
	rlca
	rlca
	ld b,a
	ld a,40
	sub b
	ld b,a
	ld a,(coord+1)
	cp b
	jp z,keyloop
	ld hl,flags
	bit 0,(hl)
	call nz,Putboat
	add a,4
	ld (coord+1),a
	jp keyloop1
;*********************************************
gauche:
	ld a,(coord+1)
	cp 4
	jp z,keyloop
	ld hl,flags
	bit 0,(hl)
	call nz,Putboat
	sub 4
	ld (coord+1),a
	jp keyloop1
;*********************************************
haut:
	ld a,(coord)
	cp 12
	jp z,keyloop
	ld hl,flags
	bit 0,(hl)
	call nz,Putboat
	sub 4
	ld (coord),a
	jp keyloop1
;*********************************************
bas:
	ld a,(htr)
	dec a
	rlca
	rlca
	ld b,a
	ld a,48
	sub b
	ld b,a
	ld a,(coord)
	cp b
	jp z,keyloop
	ld hl,flags
	bit 0,(hl)
	call nz,Putboat
	add a,4
	ld (coord),a
	jp keyloop1
;---------------------------------------------------------------------
; Quitte et sauve la partie
;---------------------------------------------------------------------
Exit:
	ld hl,flags
	bit 0,(hl)
	jr z,esuite
	ld a,(joueur)
	cp 1
	call z,Putcurs
	cp 3
	call z,Putboat
esuite:
	ld hl,sauve-1
	rst 20h
	rst 10h
	call nc,_delvar
	ld hl,1200
	call _CREATESTRNG
	ld a,b
	ex de,hl
	call _inc_ptr_ahl
	call _inc_ptr_ahl
	call _SET_ABS_DEST_ADDR
	xor a
	ld hl,_textShadow
	call _SET_ABS_SRC_ADDR
	xor a
	ld hl,167
	call _SET_MM_NUM_BYTES
	call _mm_ldir
	xor a
	ld hl,$FC00
	call _SET_ABS_SRC_ADDR
	xor a
	ld hl,1024
	call _SET_MM_NUM_BYTES
	call _mm_ldir
Exit2:
	call _clrScrn
	call _homeup
	jp $409C
;---------------------------------------------------------------------
; Affiche les grilles
;---------------------------------------------------------------------
Grille:
	push hl
	ld de,59
	ld b,11
	ld a,$ff
GLoop1:
	push de
	push bc
	ld de,1
	ld b,5
	call Ligne
	pop bc
	pop de
	add hl,de
	djnz GLoop1
	ld b,11
	pop hl
	ld a,%10000000
GLoop2:
	push bc
	push hl
	ld de,16
	ld b,41
	call Ligne
	pop hl
	rrca
	rrca
	rrca
	rrca
	cp %00001000
	jr z,noinchl
	inc hl
noinchl:
	pop bc
	djnz GLoop2
	ret
Ligne:
	ld c,a
	or (hl)
	ld (hl),a
	ld a,c
	add hl,de
	djnz Ligne
	ret
;---------------------------------------------------------------------
; Affiche le texte  la derniere ligne
;---------------------------------------------------------------------
Afftexte:
	push hl
	ld b,16*5
	ld hl,$FF90
	call 437Bh					; b 0 @ (hl)
	pop hl
	ld de,$3809
	ld (_penCol),de
	call _vputs
	ret
;---------------------------------------------------------------------
; Pause et attend <Enter>
;---------------------------------------------------------------------
pause:
	push hl
	ld hl,enter
	call _vputs
	pop hl
waitenter:
	call GET_KEY
	cp K_EXIT
	jp z,Exit
	cp K_SECOND
	jr nz,waitenter
	ret
;---------------------------------------------------------------------
; Affiche le curseur
;---------------------------------------------------------------------
Putcurs:
	push af
	ld a,(flags)
	xor 1
	ld (flags),a
	ld ix,curseur
	ld bc,(coord)
	call James_Yopp
	pop af
	ret
;---------------------------------------------------------------------
; Affiche un bateau
;---------------------------------------------------------------------
Putboat:
	push af
	ld a,(flags)
	xor 1
	ld (flags),a
	ld ix,carre
	ld bc,(coord)
	ld a,(lrg)
	cp 1
	jr z,toutenhauteur
	ld d,a
tel:
	call James_Yopp
	ld a,b
	add a,4
	ld b,a
	dec d
	jr nz,tel
	pop af
	ret
toutenhauteur:
	ld a,(htr)
	ld d,a
teh:
	call James_Yopp
	ld a,c
	add a,4
	ld c,a
	dec d
	jr nz,teh
	pop af
	ret
;---------------------------------------------------------------------
; Thanks for James Yopp ()
;---------------------------------------------------------------------
James_Yopp:
	push ix
	push de
	push bc
	call FP
	ld b,(ix)
	inc ix
DS_Loop:
	push bc
	push af
	push af
	ld b,(ix)
	ld c,(ix)
	add  a,a
	jr C,DS_EndB
DS_BLoop:
	SRL b
	add a,a
	jr nc,DS_BLoop
DS_EndB:
	pop	af
DS_CLoop:
	sla c
	srl a
	jr nc,DS_CLoop
	inc ix
	ld a,(hl)
	xor b
	ld (hl),a
	inc hl
	ld a,(hl)
	xor c
	ld (hl),a
	ld de,15
	add hl,de
	pop af
	pop bc
	djnz DS_Loop
	pop bc
	pop de
	pop ix
	ret
FP:
	push bc
	ld h,$FC
	srl b
	srl b
	srl b
	ld l,b
	ld b,c
	inc b
	ld de,16
BLoop:
	add hl,de
	djnz BLoop
	pop bc
	ld a,b
	and  %00000111
	ld b,a
	inc b
	ld  a,%00000001
ALoop:
	rrca
	djnz ALoop
	ret
;---------------------------------------------------------------------
; Thanks for Sami Khawam (sKhawam@bigfoot.com)
;---------------------------------------------------------------------
PutByte:
	push bc
	ld c,a
	ld b,8						; 8 Bits
PBNextBit:
	ld a,$C0
	out (7),a
Cont:
	rr c
	jr nc,PBSendZero
PBSendOne:
	ld a,$E8
	jr PBOutputval
PBSendZero:
	ld a,$D4
PBOutputval:
	out (7),a
	ld de,$FFFF					; For time-out
PBWaitforW0andR0:
	in a,(7)
	and 3
	jr Z,PBContinue
	in a,(7)
	and 3
	jr Z,PBContinue
	dec de
	ld a,d
	or e
	jr nz,PBWaitforW0andR0
	or 3
	jr PBEnd					; If error return.
PBContinue:
	ld a,$C0
	out (7),a
	ld de,$FFFF					; Reload time-out
PBWaitforW1andR1:
	dec de
	ld a,d
	or e
	jr z,PBEnd
	in a,(7)
	and 3
	cp 3
	jr nz,PBWaitforW1andR1
	djnz PBNextBit
	ld de,$06FF					; Small delay
PBEW:  
	dec de
	ld a,d
	or e
	jr nz,PBEW
PBEnd:
	pop bc
	ret
;---------------------------------------------------------------------
; Thanks for Randy Gluvna (gluvna@home.com)
;---------------------------------------------------------------------
GetByte:
	push bc
	ld b,008H
R0:
	ld de,0FFFFH
	jr R2
R1:
	in  a,(7)
	and 003H
	jr z,GBEnd
	cp 003H
	jr nz,R3
	in A,(7)
	and 003H
	jr z,GBEnd
	cp 003H
	jr nz,R3
R2:
	dec de
	ld a,d
	or e
	jr nz,R1
	jr GBEnd
R3:
	sub 002H
	jr nc,R8
	ld a,0D4H
	out (7),a
	rr c
	ld de,0FFFFH
R4:
	in a,(7)
	and 003H
	cp 002h
	jr z,R5
	dec de
	ld a,d
	or e
	jr nz,R4
	jr GBEnd
R5:
	ld a,0C0H
	out (7),a
	ld D,004H
R6:
	dec d
	jr z,R7
	in a,(7)
	and 003H
	cp 003H
	jr nz,R6
R7:
	djnz R0
	ld a,c
	jr GBEnd
R8:
	ld a,0E8H
	out (7),a
	rr c
	ld de,0FFFFh
R9:
	in a,(7)
	and 003H
	cp 001H
	jr z,R5
	dec de
	ld a,d
	or e
	jr nz,R9
GBEnd
	pop bc
	ret
;=====================================================================
;=====================================================================
;
carre:
 .db 3
 .db %111
 .db %111
 .db %111
curseur:
 .db 3
 .db %101
 .db %010
 .db %101
touch:
 .db 3
 .db %111
 .db %101
 .db %111
